"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.jestPreset = exports.__resetModule = exports.__singleton = exports.canInstrument = exports.getCacheKey = exports.process = exports.createTransformer = exports.digest = exports.version = exports.pathsToModuleNameMapper = exports.createJestPreset = exports.mocked = void 0;
var bs_logger_1 = require("bs-logger");
var fs_1 = require("fs");
var path_1 = require("path");
var create_jest_preset_1 = require("./config/create-jest-preset");
var paths_to_module_name_mapper_1 = require("./config/paths-to-module-name-mapper");
var ts_jest_transformer_1 = require("./ts-jest-transformer");
var logger_1 = require("./util/logger");
var messages_1 = require("./util/messages");
var testing_1 = require("./util/testing");
var version_checkers_1 = require("./util/version-checkers");
// deprecate helpers
var warn = logger_1.rootLogger.child((_a = {}, _a[bs_logger_1.LogContexts.logLevel] = bs_logger_1.LogLevels.warn, _a));
var helperMoved = function (name, helper) {
    return warn.wrap(messages_1.interpolate("The `{{helper}}` helper has been moved to `ts-jest/utils`. Use `import { {{helper}} } from 'ts-jest/utils'` instead." /* HelperMovedToUtils */, { helper: name }), helper);
};
/** @deprecated */
exports.mocked = helperMoved('mocked', testing_1.mocked);
/** @deprecated */
exports.createJestPreset = helperMoved('createJestPreset', create_jest_preset_1.createJestPreset);
/** @deprecated */
exports.pathsToModuleNameMapper = helperMoved('pathsToModuleNameMapper', paths_to_module_name_mapper_1.pathsToModuleNameMapper);
/**
 * @internal
 */
exports.version = require('../package.json').version;
/**
 * @internal
 */
exports.digest = fs_1.readFileSync(path_1.resolve(__dirname, '..', '.ts-jest-digest'), 'utf8');
var transformer;
function defaultTransformer() {
    return transformer || (transformer = createTransformer());
}
function createTransformer(baseConfig) {
    version_checkers_1.VersionCheckers.jest.warn();
    return new ts_jest_transformer_1.TsJestTransformer(baseConfig);
}
exports.createTransformer = createTransformer;
/**
 * @internal
 */
function process() {
    var _a;
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return (_a = defaultTransformer()).process.apply(_a, __spread(args));
}
exports.process = process;
/**
 * @internal
 */
function getCacheKey() {
    var _a;
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return (_a = defaultTransformer()).getCacheKey.apply(_a, __spread(args));
}
exports.getCacheKey = getCacheKey;
/**
 * @internal
 */
// we let jest doing the instrumentation, it does it well
exports.canInstrument = false;
var jestPreset = create_jest_preset_1.createJestPreset();
exports.jestPreset = jestPreset;
/**
 * @internal
 */
// for tests
exports.__singleton = function () { return transformer; };
/**
 * @internal
 */
exports.__resetModule = function () { return (transformer = undefined); };
